<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex18.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex18.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex18.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex18.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 18: Names, Variables, Code, Functions</h1>
                <p>Big title, right?  I am about to introduce you to <em>the function</em>!  Dum dum dah!  Every programmer will go on and on about functions and all the different ideas about how they work and what they do, but I will give you the simplest explanation you can use right now.</p>
<p>Functions do three things:</p>
<ol class="arabic simple">
<li>They name pieces of code the way variables name strings and numbers.</li>
<li>They take arguments the way your scripts take <tt class="docutils literal">argv</tt>.</li>
<li>Using 1 and 2 they let you make your own &quot;mini-scripts&quot; or &quot;tiny commands.&quot;</li>
</ol>
<p>You can create a function by using the word <tt class="docutils literal">def</tt> in Python.  I'm going to have you make four different functions that work like your scripts, and I'll then show you how each one is related.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex18.py-idio.html-1"></a><span class="c1"># this one is like your scripts with argv</span>
<a name="python--ex18.py-idio.html-2"></a><span class="k">def</span> <span class="nf">print_two</span><span class="p">(</span><span class="o">*</span><span class="n">args</span><span class="p">):</span>
<a name="python--ex18.py-idio.html-3"></a>    <span class="n">arg1</span><span class="p">,</span> <span class="n">arg2</span> <span class="o">=</span> <span class="n">args</span>
<a name="python--ex18.py-idio.html-4"></a>    <span class="k">print</span> <span class="s2">&quot;arg1: </span><span class="si">%r</span><span class="s2">, arg2: </span><span class="si">%r</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">arg1</span><span class="p">,</span> <span class="n">arg2</span><span class="p">)</span>
<a name="python--ex18.py-idio.html-5"></a>
<a name="python--ex18.py-idio.html-6"></a><span class="c1"># ok, that *args is actually pointless, we can just do this</span>
<a name="python--ex18.py-idio.html-7"></a><span class="k">def</span> <span class="nf">print_two_again</span><span class="p">(</span><span class="n">arg1</span><span class="p">,</span> <span class="n">arg2</span><span class="p">):</span>
<a name="python--ex18.py-idio.html-8"></a>    <span class="k">print</span> <span class="s2">&quot;arg1: </span><span class="si">%r</span><span class="s2">, arg2: </span><span class="si">%r</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">arg1</span><span class="p">,</span> <span class="n">arg2</span><span class="p">)</span>
<a name="python--ex18.py-idio.html-9"></a>
<a name="python--ex18.py-idio.html-10"></a><span class="c1"># this just takes one argument</span>
<a name="python--ex18.py-idio.html-11"></a><span class="k">def</span> <span class="nf">print_one</span><span class="p">(</span><span class="n">arg1</span><span class="p">):</span>
<a name="python--ex18.py-idio.html-12"></a>    <span class="k">print</span> <span class="s2">&quot;arg1: </span><span class="si">%r</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">arg1</span>
<a name="python--ex18.py-idio.html-13"></a>
<a name="python--ex18.py-idio.html-14"></a><span class="c1"># this one takes no arguments</span>
<a name="python--ex18.py-idio.html-15"></a><span class="k">def</span> <span class="nf">print_none</span><span class="p">():</span>
<a name="python--ex18.py-idio.html-16"></a>    <span class="k">print</span> <span class="s2">&quot;I got nothin&#39;.&quot;</span>
<a name="python--ex18.py-idio.html-17"></a>
<a name="python--ex18.py-idio.html-18"></a>
<a name="python--ex18.py-idio.html-19"></a><span class="n">print_two</span><span class="p">(</span><span class="s2">&quot;Zed&quot;</span><span class="p">,</span><span class="s2">&quot;Shaw&quot;</span><span class="p">)</span>
<a name="python--ex18.py-idio.html-20"></a><span class="n">print_two_again</span><span class="p">(</span><span class="s2">&quot;Zed&quot;</span><span class="p">,</span><span class="s2">&quot;Shaw&quot;</span><span class="p">)</span>
<a name="python--ex18.py-idio.html-21"></a><span class="n">print_one</span><span class="p">(</span><span class="s2">&quot;First!&quot;</span><span class="p">)</span>
<a name="python--ex18.py-idio.html-22"></a><span class="n">print_none</span><span class="p">()</span>
</pre></div>
</td></tr></table><p>Let's break down the first function, <tt class="docutils literal">print_two</tt>, which is the most similar to what you already know from making scripts:</p>
<ol class="arabic simple">
<li>First we tell Python we want to make a function using <tt class="docutils literal">def</tt> for &quot;define&quot;.</li>
<li>On the same line as <tt class="docutils literal">def</tt> we give the function a name. In this case we just called it &quot;print_two&quot; but it could also be &quot;peanuts&quot;. It doesn't matter, except that your function should have a short name that says what it does.</li>
<li>Then we tell it we want <tt class="docutils literal">*args</tt> (asterisk args) which is a lot like your <tt class="docutils literal">argv</tt> parameter but for functions. This <em>has</em> to go inside <tt class="docutils literal">()</tt> parentheses to work.</li>
<li>Then we end this line with a <tt class="docutils literal">:</tt> colon, and start indenting.</li>
<li>After the colon all the lines that are indented four spaces will become attached to this name, <tt class="docutils literal">print_two</tt>.  Our first indented line is one that unpacks the arguments the same as with your scripts.</li>
<li>To demonstrate how it works we print these arguments out, just like we would in a script.</li>
</ol>
<p>The problem with <tt class="docutils literal">print_two</tt> is that it's not the easiest way to make a function.  In Python we can skip the whole unpacking arguments and just use the names we want right inside <tt class="docutils literal">()</tt>.  That's what <tt class="docutils literal">print_two_again</tt> does.</p>
<p>After that you have an example of how you make a function that takes one argument in <tt class="docutils literal">print_one</tt>.</p>
<p>Finally you have a function that has no arguments in <tt class="docutils literal">print_none</tt>.</p>
<div class="warning">
<p class="first admonition-title">Warning</p>
<p class="last">This is very important. Do <em>not</em> get discouraged right now if this doesn't quite make sense.  We're going to do a few exercises linking functions to your scripts and show you how to make more.  For now just keep thinking &quot;mini-script&quot; when I say &quot;function&quot; and keep playing with them.</p>
</div>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<p>If you run <tt class="docutils literal">ex18.py</tt> you should see:</p>
<div class="highlight"><pre><span></span><a name="python--ex18.sh-idio-shint-pyg.html-1"></a><span class="gp">$</span> python ex18.py
<a name="python--ex18.sh-idio-shint-pyg.html-2"></a><span class="go">arg1: &#39;Zed&#39;, arg2: &#39;Shaw&#39;</span>
<a name="python--ex18.sh-idio-shint-pyg.html-3"></a><span class="go">arg1: &#39;Zed&#39;, arg2: &#39;Shaw&#39;</span>
<a name="python--ex18.sh-idio-shint-pyg.html-4"></a><span class="go">arg1: &#39;First!&#39;</span>
<a name="python--ex18.sh-idio-shint-pyg.html-5"></a><span class="go">I got nothin&#39;.</span>
</pre></div><p>Right away you can see how a function works.  Notice that you used your functions the way you use things like <tt class="docutils literal">exists</tt>, <tt class="docutils literal">open</tt>, and other &quot;commands.&quot;  In fact, I've been tricking you because in Python those &quot;commands&quot; are just functions.  This means you can make your own commands and use them in your scripts too.</p>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<p>Create a <em>function checklist</em> for later exercises.  Write these checks on an index card and keep it by you while you complete the rest of these exercises or until you feel you do not need the index card anymore:</p>
<ol class="arabic simple">
<li>Did you start your function definition with <tt class="docutils literal">def</tt>?</li>
<li>Does your function name have only characters and <tt class="docutils literal">_</tt> (underscore) characters?</li>
<li>Did you put an open parenthesis <tt class="docutils literal">(</tt> right after the function name?</li>
<li>Did you put your arguments after the parenthesis <tt class="docutils literal">(</tt> separated by commas?</li>
<li>Did you make each argument unique (meaning no duplicated names)?</li>
<li>Did you put a close parenthesis and a colon <tt class="docutils literal">):</tt> after the arguments?</li>
<li>Did you indent all lines of code you want in the function four spaces?  No more, no less.</li>
<li>Did you &quot;end&quot; your function by going back to writing with no indent (<tt class="docutils literal">dedenting</tt> we call it)?</li>
</ol>
<p>When you run (&quot;use&quot; or &quot;call&quot;) a function, check these things:</p>
<ol class="arabic simple">
<li>Did you call/use/run this function by typing its name?</li>
<li>Did you put the <tt class="docutils literal">(</tt> character after the name to run it?</li>
<li>Did you put the values you want into the parenthesis separated by commas?</li>
<li>Did you end the function call with a <tt class="docutils literal">)</tt> character?</li>
</ol>
<p>Use these two checklists on the remaining lessons until you do not need them anymore.</p>
<p>Finally, repeat this a few times to yourself:</p>
<pre class="literal-block">
&quot;To 'run,' 'call,' or 'use' a function all mean the same thing.&quot;
</pre>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>What's allowed for a function name?</dt>
<dd>The same as variable names. Anything that doesn't start with a number, and is letters, numbers, and underscores will work.</dd>
<dt>What does the <tt class="docutils literal">*</tt> in <tt class="docutils literal">*args</tt> do?</dt>
<dd>That tells Python to take all the arguments to the function and then put them in <tt class="docutils literal">args</tt> as a list.  It's like <tt class="docutils literal">argv</tt> that you've been using, but for functions.  It's not normally used too often unless specifically needed.</dd>
<dt>This feels really boring and monotonous.</dt>
<dd>That's good. It means you're starting to get better at typing in the code and understanding what it does.  To make it less boring, take everything I tell you to type in, and then break it on purpose.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex18.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex18.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
